
?-ensure_loaded(lib_sets).
?-ensure_loaded(lib_compatibility_for_swi).



epsilon_hull(TempHull,LastAdded,EpsilonTransitions,Hull):-
   findall( NextLevelNode, Start^(member(Start,LastAdded),member([Start,NextLevelNode],EpsilonTransitions) ), NextLevel ),
   make_sorted_set(NextLevel,NextLevelSet),
   set_union_sorted_sets(NextLevelSet,TempHull,NewHull),
   /*
      if NextLevel is subset of TempHull, then set_union sets the elements of
      NewHull in the same order as TempHull. Therefore the following comparison
      is true iff NextLevel is not a subset of TempHull.
   */
   not((NewHull = TempHull)),          /**/
   !,
   epsilon_hull(NewHull,NextLevelSet,EpsilonTransitions,Hull).
epsilon_hull(Hull,_,_,Hull).


hull_transitions_hull(StartStates,Symbol,Delta,EpsilonTransitions,Hull):-
   mergesort(StartStates,SortedStartStates),
   epsilon_hull(SortedStartStates,SortedStartStates,EpsilonTransitions,StartStatesHull),
   findall(TransitionTarget, Start^(member(Start, StartStatesHull),
                               member([Start,Symbol,TransitionTarget],Delta)), ReachableStates),
   epsilon_hull(ReachableStates,ReachableStates,EpsilonTransitions,Hull).



epsilon_nfa_to_nfa(epsilon_nfa(Q,Sigma,Delta,EpsilonTransitions,StartState,FinalStates),
                           nfa(Q,Sigma,NFADelta,StartState,NFAFinalStates)):-
   findall( [Start,Symbol,Target],
                                  Targets^(member(Start,Q),
                                  member(Symbol, Sigma),
                                  hull_transitions_hull([Start],Symbol,Delta,EpsilonTransitions,Targets),
                                  member(Target,Targets)),
        NFADelta),
   findall(X, EpsHull^(member(X,Q),
                       epsilon_hull([X],[X],EpsilonTransitions,EpsHull),
                       set_intersection(EpsHull,FinalStates,[_|_])),
                    NFAFinalStates).














